/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// NotificationCategory the model 'NotificationCategory'
type NotificationCategory string

// List of NotificationCategory
const (
	NotificationCategoryBilling NotificationCategory = "billing"
	NotificationCategoryConversation NotificationCategory = "conversation"
	NotificationCategoryContact NotificationCategory = "contact"
	NotificationCategoryTask NotificationCategory = "task"
	NotificationCategorySystem NotificationCategory = "system"
)

// All allowed values of NotificationCategory enum
var AllowedNotificationCategoryEnumValues = []NotificationCategory{
	"billing",
	"conversation",
	"contact",
	"task",
	"system",
}

func (v *NotificationCategory) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := NotificationCategory(value)
	for _, existing := range AllowedNotificationCategoryEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid NotificationCategory", value)
}

// NewNotificationCategoryFromValue returns a pointer to a valid NotificationCategory
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewNotificationCategoryFromValue(v string) (*NotificationCategory, error) {
	ev := NotificationCategory(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for NotificationCategory: valid values are %v", v, AllowedNotificationCategoryEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v NotificationCategory) IsValid() bool {
	for _, existing := range AllowedNotificationCategoryEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to NotificationCategory value
func (v NotificationCategory) Ptr() *NotificationCategory {
	return &v
}

type NullableNotificationCategory struct {
	value *NotificationCategory
	isSet bool
}

func (v NullableNotificationCategory) Get() *NotificationCategory {
	return v.value
}

func (v *NullableNotificationCategory) Set(val *NotificationCategory) {
	v.value = val
	v.isSet = true
}

func (v NullableNotificationCategory) IsSet() bool {
	return v.isSet
}

func (v *NullableNotificationCategory) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNotificationCategory(val *NotificationCategory) *NullableNotificationCategory {
	return &NullableNotificationCategory{value: val, isSet: true}
}

func (v NullableNotificationCategory) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNotificationCategory) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

